﻿using Infragistics.Windows.DataPresenter.Events;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace test
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public List<Foo> foos { get; set; }

        public MainWindow()
        {
            foos = new List<Foo>
            {
                new Foo() { name = "hi", bars = new List<Bar> { new Bar() { count = 1 } } },
                new Foo() { name = "mom", bars = new List<Bar> { new Bar() { count = 2 }, new Bar() {count = 2 } } },
                new Foo() { name = "hello", bars = new List<Bar> { new Bar() { count = 3 }, new Bar() {count = 3 }, new Bar() { count = 3 } } }
            };

            DataContext = this;
            InitializeComponent();
        }

        private void XamDataGrid_QuerySummaryResult(object sender, QuerySummaryResultEventArgs e)
        {
            //var items = thegrid.DataSource as IEnumerable<Foo>;
            //Getting the DataItems for the child level
            var childItems = e.Summary.ParentCollection.Records.Select(r => (r as DataRecord).DataItem).ToList();
            
            //Calculating the sum of the records.
            double sum = childItems.Select(i => (int)i.GetType().GetProperty(e.Summary.SourceField.Name).GetValue(i, null)).Sum();

            //Setting the value
            e.SetSummaryValue(sum);
        }
    }
}
